/*******************************************************************************
 * Copyright (c) 2014 Bosch Software Innovations GmbH and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * and Eclipse Distribution License v1.0 which accompany this distribution.
 *
 * The Eclipse Public License is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * The Eclipse Distribution License is available at
 * http://www.eclipse.org/org/documents/edl-v10.php.
 *
 * Contributors:
 * Bosch Software Innovations GmbH - Please refer to git log
 *
 *******************************************************************************/
/*
 * generated by Xtext
 */
grammar InternalFunctionblock;

options {
	superClass=AbstractInternalAntlrParser;
}

@lexer::header {
package org.eclipse.vorto.editor.functionblock.parser.antlr.internal;

// Hack: Use our own Lexer superclass by means of import. 
// Currently there is no other way to specify the superclass for the lexer.
import org.eclipse.xtext.parser.antlr.Lexer;
}

@parser::header {
package org.eclipse.vorto.editor.functionblock.parser.antlr.internal;

import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.common.util.Enumerator;
import org.eclipse.xtext.parser.antlr.AbstractInternalAntlrParser;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.parser.antlr.AntlrDatatypeRuleToken;
import org.eclipse.vorto.editor.functionblock.services.FunctionblockGrammarAccess;

}

@parser::members {

 	private FunctionblockGrammarAccess grammarAccess;

    public InternalFunctionblockParser(TokenStream input, FunctionblockGrammarAccess grammarAccess) {
        this(input);
        this.grammarAccess = grammarAccess;
        registerRules(grammarAccess.getGrammar());
    }

    @Override
    protected String getFirstRuleName() {
    	return "FunctionblockModel";
   	}

   	@Override
   	protected FunctionblockGrammarAccess getGrammarAccess() {
   		return grammarAccess;
   	}

}

@rulecatch {
    catch (RecognitionException re) {
        recover(input,re);
        appendSkippedTokens();
    }
}

// Entry rule entryRuleFunctionblockModel
entryRuleFunctionblockModel returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getFunctionblockModelRule()); }
	iv_ruleFunctionblockModel=ruleFunctionblockModel
	{ $current=$iv_ruleFunctionblockModel.current; }
	EOF;

// Rule FunctionblockModel
ruleFunctionblockModel returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			{
				$current = forceCreateModelElement(
					grammarAccess.getFunctionblockModelAccess().getFunctionblockModelAction_0(),
					$current);
			}
		)
		otherlv_1='namespace'
		{
			newLeafNode(otherlv_1, grammarAccess.getFunctionblockModelAccess().getNamespaceKeyword_1());
		}
		(
			(
				{
					newCompositeNode(grammarAccess.getFunctionblockModelAccess().getNamespaceQualifiedNameParserRuleCall_2_0());
				}
				lv_namespace_2_0=ruleQualifiedName
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getFunctionblockModelRule());
					}
					set(
						$current,
						"namespace",
						lv_namespace_2_0,
						"org.eclipse.vorto.editor.datatype.Datatype.QualifiedName");
					afterParserOrEnumRuleCall();
				}
			)
		)
		otherlv_3='version'
		{
			newLeafNode(otherlv_3, grammarAccess.getFunctionblockModelAccess().getVersionKeyword_3());
		}
		(
			(
				lv_version_4_0=RULE_VERSION
				{
					newLeafNode(lv_version_4_0, grammarAccess.getFunctionblockModelAccess().getVersionVERSIONTerminalRuleCall_4_0());
				}
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getFunctionblockModelRule());
					}
					setWithLastConsumed(
						$current,
						"version",
						lv_version_4_0,
						"org.eclipse.vorto.editor.datatype.Datatype.VERSION");
				}
			)
		)
		otherlv_5='displayname'
		{
			newLeafNode(otherlv_5, grammarAccess.getFunctionblockModelAccess().getDisplaynameKeyword_5());
		}
		(
			(
				lv_displayname_6_0=RULE_STRING
				{
					newLeafNode(lv_displayname_6_0, grammarAccess.getFunctionblockModelAccess().getDisplaynameSTRINGTerminalRuleCall_6_0());
				}
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getFunctionblockModelRule());
					}
					setWithLastConsumed(
						$current,
						"displayname",
						lv_displayname_6_0,
						"org.eclipse.xtext.common.Terminals.STRING");
				}
			)
		)
		(
			otherlv_7='description'
			{
				newLeafNode(otherlv_7, grammarAccess.getFunctionblockModelAccess().getDescriptionKeyword_7_0());
			}
			(
				(
					lv_description_8_0=RULE_STRING
					{
						newLeafNode(lv_description_8_0, grammarAccess.getFunctionblockModelAccess().getDescriptionSTRINGTerminalRuleCall_7_1_0());
					}
					{
						if ($current==null) {
							$current = createModelElement(grammarAccess.getFunctionblockModelRule());
						}
						setWithLastConsumed(
							$current,
							"description",
							lv_description_8_0,
							"org.eclipse.xtext.common.Terminals.STRING");
					}
				)
			)
		)?
		otherlv_9='category'
		{
			newLeafNode(otherlv_9, grammarAccess.getFunctionblockModelAccess().getCategoryKeyword_8());
		}
		(
			(
				{
					newCompositeNode(grammarAccess.getFunctionblockModelAccess().getCategoryCATEGORYParserRuleCall_9_0());
				}
				lv_category_10_0=ruleCATEGORY
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getFunctionblockModelRule());
					}
					set(
						$current,
						"category",
						lv_category_10_0,
						"org.eclipse.vorto.editor.functionblock.Functionblock.CATEGORY");
					afterParserOrEnumRuleCall();
				}
			)
		)
		(
			(
				{
					newCompositeNode(grammarAccess.getFunctionblockModelAccess().getReferencesModelReferenceParserRuleCall_10_0());
				}
				lv_references_11_0=ruleModelReference
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getFunctionblockModelRule());
					}
					add(
						$current,
						"references",
						lv_references_11_0,
						"org.eclipse.vorto.editor.datatype.Datatype.ModelReference");
					afterParserOrEnumRuleCall();
				}
			)
		)*
		otherlv_12='functionblock'
		{
			newLeafNode(otherlv_12, grammarAccess.getFunctionblockModelAccess().getFunctionblockKeyword_11());
		}
		(
			(
				lv_name_13_0=RULE_ID
				{
					newLeafNode(lv_name_13_0, grammarAccess.getFunctionblockModelAccess().getNameIDTerminalRuleCall_12_0());
				}
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getFunctionblockModelRule());
					}
					setWithLastConsumed(
						$current,
						"name",
						lv_name_13_0,
						"org.eclipse.xtext.common.Terminals.ID");
				}
			)
		)
		(
			otherlv_14='extends'
			{
				newLeafNode(otherlv_14, grammarAccess.getFunctionblockModelAccess().getExtendsKeyword_13_0());
			}
			(
				(
					{
						if ($current==null) {
							$current = createModelElement(grammarAccess.getFunctionblockModelRule());
						}
					}
					{
						newCompositeNode(grammarAccess.getFunctionblockModelAccess().getSuperTypeFunctionblockModelCrossReference_13_1_0());
					}
					ruleQualifiedName
					{
						afterParserOrEnumRuleCall();
					}
				)
			)
		)?
		otherlv_16='{'
		{
			newLeafNode(otherlv_16, grammarAccess.getFunctionblockModelAccess().getLeftCurlyBracketKeyword_14());
		}
		(
			(
				{
					newCompositeNode(grammarAccess.getFunctionblockModelAccess().getFunctionblockFunctionBlockParserRuleCall_15_0());
				}
				lv_functionblock_17_0=ruleFunctionBlock
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getFunctionblockModelRule());
					}
					set(
						$current,
						"functionblock",
						lv_functionblock_17_0,
						"org.eclipse.vorto.editor.functionblock.Functionblock.FunctionBlock");
					afterParserOrEnumRuleCall();
				}
			)
		)
		otherlv_18='}'
		{
			newLeafNode(otherlv_18, grammarAccess.getFunctionblockModelAccess().getRightCurlyBracketKeyword_16());
		}
		(
			(
				{
					newCompositeNode(grammarAccess.getFunctionblockModelAccess().getEntitiesEntityParserRuleCall_17_0());
				}
				lv_entities_19_0=ruleEntity
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getFunctionblockModelRule());
					}
					add(
						$current,
						"entities",
						lv_entities_19_0,
						"org.eclipse.vorto.editor.datatype.Datatype.Entity");
					afterParserOrEnumRuleCall();
				}
			)
		)*
		(
			(
				{
					newCompositeNode(grammarAccess.getFunctionblockModelAccess().getEnumsEnumParserRuleCall_18_0());
				}
				lv_enums_20_0=ruleEnum
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getFunctionblockModelRule());
					}
					add(
						$current,
						"enums",
						lv_enums_20_0,
						"org.eclipse.vorto.editor.datatype.Datatype.Enum");
					afterParserOrEnumRuleCall();
				}
			)
		)*
	)
;

// Entry rule entryRuleFunctionBlock
entryRuleFunctionBlock returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getFunctionBlockRule()); }
	iv_ruleFunctionBlock=ruleFunctionBlock
	{ $current=$iv_ruleFunctionBlock.current; }
	EOF;

// Rule FunctionBlock
ruleFunctionBlock returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			{
				$current = forceCreateModelElement(
					grammarAccess.getFunctionBlockAccess().getFunctionBlockAction_0(),
					$current);
			}
		)
		(
			(
				{
					newCompositeNode(grammarAccess.getFunctionBlockAccess().getConfigurationConfigurationParserRuleCall_1_0());
				}
				lv_configuration_1_0=ruleConfiguration
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getFunctionBlockRule());
					}
					set(
						$current,
						"configuration",
						lv_configuration_1_0,
						"org.eclipse.vorto.editor.functionblock.Functionblock.Configuration");
					afterParserOrEnumRuleCall();
				}
			)
		)?
		(
			(
				{
					newCompositeNode(grammarAccess.getFunctionBlockAccess().getStatusStatusParserRuleCall_2_0());
				}
				lv_status_2_0=ruleStatus
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getFunctionBlockRule());
					}
					set(
						$current,
						"status",
						lv_status_2_0,
						"org.eclipse.vorto.editor.functionblock.Functionblock.Status");
					afterParserOrEnumRuleCall();
				}
			)
		)?
		(
			(
				{
					newCompositeNode(grammarAccess.getFunctionBlockAccess().getFaultFaultParserRuleCall_3_0());
				}
				lv_fault_3_0=ruleFault
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getFunctionBlockRule());
					}
					set(
						$current,
						"fault",
						lv_fault_3_0,
						"org.eclipse.vorto.editor.functionblock.Functionblock.Fault");
					afterParserOrEnumRuleCall();
				}
			)
		)?
		(
			otherlv_4='events'
			{
				newLeafNode(otherlv_4, grammarAccess.getFunctionBlockAccess().getEventsKeyword_4_0());
			}
			otherlv_5='{'
			{
				newLeafNode(otherlv_5, grammarAccess.getFunctionBlockAccess().getLeftCurlyBracketKeyword_4_1());
			}
			(
				(
					{
						newCompositeNode(grammarAccess.getFunctionBlockAccess().getEventsEventParserRuleCall_4_2_0());
					}
					lv_events_6_0=ruleEvent
					{
						if ($current==null) {
							$current = createModelElementForParent(grammarAccess.getFunctionBlockRule());
						}
						add(
							$current,
							"events",
							lv_events_6_0,
							"org.eclipse.vorto.editor.functionblock.Functionblock.Event");
						afterParserOrEnumRuleCall();
					}
				)
			)*
			otherlv_7='}'
			{
				newLeafNode(otherlv_7, grammarAccess.getFunctionBlockAccess().getRightCurlyBracketKeyword_4_3());
			}
		)?
		(
			otherlv_8='operations'
			{
				newLeafNode(otherlv_8, grammarAccess.getFunctionBlockAccess().getOperationsKeyword_5_0());
			}
			otherlv_9='{'
			{
				newLeafNode(otherlv_9, grammarAccess.getFunctionBlockAccess().getLeftCurlyBracketKeyword_5_1());
			}
			(
				(
					{
						newCompositeNode(grammarAccess.getFunctionBlockAccess().getOperationsOperationParserRuleCall_5_2_0());
					}
					lv_operations_10_0=ruleOperation
					{
						if ($current==null) {
							$current = createModelElementForParent(grammarAccess.getFunctionBlockRule());
						}
						add(
							$current,
							"operations",
							lv_operations_10_0,
							"org.eclipse.vorto.editor.functionblock.Functionblock.Operation");
						afterParserOrEnumRuleCall();
					}
				)
			)*
			otherlv_11='}'
			{
				newLeafNode(otherlv_11, grammarAccess.getFunctionBlockAccess().getRightCurlyBracketKeyword_5_3());
			}
		)?
	)
;

// Entry rule entryRuleConfiguration
entryRuleConfiguration returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getConfigurationRule()); }
	iv_ruleConfiguration=ruleConfiguration
	{ $current=$iv_ruleConfiguration.current; }
	EOF;

// Rule Configuration
ruleConfiguration returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			{
				$current = forceCreateModelElement(
					grammarAccess.getConfigurationAccess().getConfigurationAction_0(),
					$current);
			}
		)
		otherlv_1='configuration'
		{
			newLeafNode(otherlv_1, grammarAccess.getConfigurationAccess().getConfigurationKeyword_1());
		}
		otherlv_2='{'
		{
			newLeafNode(otherlv_2, grammarAccess.getConfigurationAccess().getLeftCurlyBracketKeyword_2());
		}
		(
			(
				{
					newCompositeNode(grammarAccess.getConfigurationAccess().getPropertiesPropertyParserRuleCall_3_0());
				}
				lv_properties_3_0=ruleProperty
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getConfigurationRule());
					}
					add(
						$current,
						"properties",
						lv_properties_3_0,
						"org.eclipse.vorto.editor.datatype.Datatype.Property");
					afterParserOrEnumRuleCall();
				}
			)
		)*
		otherlv_4='}'
		{
			newLeafNode(otherlv_4, grammarAccess.getConfigurationAccess().getRightCurlyBracketKeyword_4());
		}
	)
;

// Entry rule entryRuleStatus
entryRuleStatus returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getStatusRule()); }
	iv_ruleStatus=ruleStatus
	{ $current=$iv_ruleStatus.current; }
	EOF;

// Rule Status
ruleStatus returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			{
				$current = forceCreateModelElement(
					grammarAccess.getStatusAccess().getStatusAction_0(),
					$current);
			}
		)
		otherlv_1='status'
		{
			newLeafNode(otherlv_1, grammarAccess.getStatusAccess().getStatusKeyword_1());
		}
		otherlv_2='{'
		{
			newLeafNode(otherlv_2, grammarAccess.getStatusAccess().getLeftCurlyBracketKeyword_2());
		}
		(
			(
				{
					newCompositeNode(grammarAccess.getStatusAccess().getPropertiesPropertyParserRuleCall_3_0());
				}
				lv_properties_3_0=ruleProperty
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getStatusRule());
					}
					add(
						$current,
						"properties",
						lv_properties_3_0,
						"org.eclipse.vorto.editor.datatype.Datatype.Property");
					afterParserOrEnumRuleCall();
				}
			)
		)*
		otherlv_4='}'
		{
			newLeafNode(otherlv_4, grammarAccess.getStatusAccess().getRightCurlyBracketKeyword_4());
		}
	)
;

// Entry rule entryRuleFault
entryRuleFault returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getFaultRule()); }
	iv_ruleFault=ruleFault
	{ $current=$iv_ruleFault.current; }
	EOF;

// Rule Fault
ruleFault returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			{
				$current = forceCreateModelElement(
					grammarAccess.getFaultAccess().getFaultAction_0(),
					$current);
			}
		)
		otherlv_1='fault'
		{
			newLeafNode(otherlv_1, grammarAccess.getFaultAccess().getFaultKeyword_1());
		}
		otherlv_2='{'
		{
			newLeafNode(otherlv_2, grammarAccess.getFaultAccess().getLeftCurlyBracketKeyword_2());
		}
		(
			(
				{
					newCompositeNode(grammarAccess.getFaultAccess().getPropertiesPropertyParserRuleCall_3_0());
				}
				lv_properties_3_0=ruleProperty
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getFaultRule());
					}
					add(
						$current,
						"properties",
						lv_properties_3_0,
						"org.eclipse.vorto.editor.datatype.Datatype.Property");
					afterParserOrEnumRuleCall();
				}
			)
		)*
		otherlv_4='}'
		{
			newLeafNode(otherlv_4, grammarAccess.getFaultAccess().getRightCurlyBracketKeyword_4());
		}
	)
;

// Entry rule entryRuleOperation
entryRuleOperation returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getOperationRule()); }
	iv_ruleOperation=ruleOperation
	{ $current=$iv_ruleOperation.current; }
	EOF;

// Rule Operation
ruleOperation returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			(
				lv_breakable_0_0='breakable'
				{
					newLeafNode(lv_breakable_0_0, grammarAccess.getOperationAccess().getBreakableBreakableKeyword_0_0());
				}
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getOperationRule());
					}
					setWithLastConsumed($current, "breakable", true, "breakable");
				}
			)
		)?
		(
			(
				lv_name_1_0=RULE_ID
				{
					newLeafNode(lv_name_1_0, grammarAccess.getOperationAccess().getNameIDTerminalRuleCall_1_0());
				}
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getOperationRule());
					}
					setWithLastConsumed(
						$current,
						"name",
						lv_name_1_0,
						"org.eclipse.xtext.common.Terminals.ID");
				}
			)
		)
		otherlv_2='('
		{
			newLeafNode(otherlv_2, grammarAccess.getOperationAccess().getLeftParenthesisKeyword_2());
		}
		(
			(
				(
					{
						newCompositeNode(grammarAccess.getOperationAccess().getParamsParamParserRuleCall_3_0_0());
					}
					lv_params_3_0=ruleParam
					{
						if ($current==null) {
							$current = createModelElementForParent(grammarAccess.getOperationRule());
						}
						add(
							$current,
							"params",
							lv_params_3_0,
							"org.eclipse.vorto.editor.functionblock.Functionblock.Param");
						afterParserOrEnumRuleCall();
					}
				)
			)
			(
				otherlv_4=','
				{
					newLeafNode(otherlv_4, grammarAccess.getOperationAccess().getCommaKeyword_3_1_0());
				}
				(
					(
						{
							newCompositeNode(grammarAccess.getOperationAccess().getParamsParamParserRuleCall_3_1_1_0());
						}
						lv_params_5_0=ruleParam
						{
							if ($current==null) {
								$current = createModelElementForParent(grammarAccess.getOperationRule());
							}
							add(
								$current,
								"params",
								lv_params_5_0,
								"org.eclipse.vorto.editor.functionblock.Functionblock.Param");
							afterParserOrEnumRuleCall();
						}
					)
				)
			)*
		)?
		otherlv_6=')'
		{
			newLeafNode(otherlv_6, grammarAccess.getOperationAccess().getRightParenthesisKeyword_4());
		}
		(
			otherlv_7='returns'
			{
				newLeafNode(otherlv_7, grammarAccess.getOperationAccess().getReturnsKeyword_5_0());
			}
			(
				(
					{
						newCompositeNode(grammarAccess.getOperationAccess().getReturnTypeReturnTypeParserRuleCall_5_1_0());
					}
					lv_returnType_8_0=ruleReturnType
					{
						if ($current==null) {
							$current = createModelElementForParent(grammarAccess.getOperationRule());
						}
						set(
							$current,
							"returnType",
							lv_returnType_8_0,
							"org.eclipse.vorto.editor.functionblock.Functionblock.ReturnType");
						afterParserOrEnumRuleCall();
					}
				)
			)
		)?
		(
			(
				lv_description_9_0=RULE_STRING
				{
					newLeafNode(lv_description_9_0, grammarAccess.getOperationAccess().getDescriptionSTRINGTerminalRuleCall_6_0());
				}
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getOperationRule());
					}
					setWithLastConsumed(
						$current,
						"description",
						lv_description_9_0,
						"org.eclipse.xtext.common.Terminals.STRING");
				}
			)
		)?
	)
;

// Entry rule entryRuleReturnType
entryRuleReturnType returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getReturnTypeRule()); }
	iv_ruleReturnType=ruleReturnType
	{ $current=$iv_ruleReturnType.current; }
	EOF;

// Rule ReturnType
ruleReturnType returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		{
			newCompositeNode(grammarAccess.getReturnTypeAccess().getReturnObjectTypeParserRuleCall_0());
		}
		this_ReturnObjectType_0=ruleReturnObjectType
		{
			$current = $this_ReturnObjectType_0.current;
			afterParserOrEnumRuleCall();
		}
		    |
		{
			newCompositeNode(grammarAccess.getReturnTypeAccess().getReturnPrimitiveTypeParserRuleCall_1());
		}
		this_ReturnPrimitiveType_1=ruleReturnPrimitiveType
		{
			$current = $this_ReturnPrimitiveType_1.current;
			afterParserOrEnumRuleCall();
		}
	)
;

// Entry rule entryRuleReturnObjectType
entryRuleReturnObjectType returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getReturnObjectTypeRule()); }
	iv_ruleReturnObjectType=ruleReturnObjectType
	{ $current=$iv_ruleReturnObjectType.current; }
	EOF;

// Rule ReturnObjectType
ruleReturnObjectType returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			(
				lv_multiplicity_0_0='multiple'
				{
					newLeafNode(lv_multiplicity_0_0, grammarAccess.getReturnObjectTypeAccess().getMultiplicityMultipleKeyword_0_0());
				}
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getReturnObjectTypeRule());
					}
					setWithLastConsumed($current, "multiplicity", true, "multiple");
				}
			)
		)?
		(
			(
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getReturnObjectTypeRule());
					}
				}
				{
					newCompositeNode(grammarAccess.getReturnObjectTypeAccess().getReturnTypeTypeCrossReference_1_0());
				}
				ruleQualifiedName
				{
					afterParserOrEnumRuleCall();
				}
			)
		)
	)
;

// Entry rule entryRuleReturnPrimitiveType
entryRuleReturnPrimitiveType returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getReturnPrimitiveTypeRule()); }
	iv_ruleReturnPrimitiveType=ruleReturnPrimitiveType
	{ $current=$iv_ruleReturnPrimitiveType.current; }
	EOF;

// Rule ReturnPrimitiveType
ruleReturnPrimitiveType returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			(
				lv_multiplicity_0_0='multiple'
				{
					newLeafNode(lv_multiplicity_0_0, grammarAccess.getReturnPrimitiveTypeAccess().getMultiplicityMultipleKeyword_0_0());
				}
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getReturnPrimitiveTypeRule());
					}
					setWithLastConsumed($current, "multiplicity", true, "multiple");
				}
			)
		)?
		(
			(
				{
					newCompositeNode(grammarAccess.getReturnPrimitiveTypeAccess().getReturnTypePrimitiveTypeEnumRuleCall_1_0());
				}
				lv_returnType_1_0=rulePrimitiveType
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getReturnPrimitiveTypeRule());
					}
					set(
						$current,
						"returnType",
						lv_returnType_1_0,
						"org.eclipse.vorto.editor.datatype.Datatype.PrimitiveType");
					afterParserOrEnumRuleCall();
				}
			)
		)
		(
			otherlv_2='<'
			{
				newLeafNode(otherlv_2, grammarAccess.getReturnPrimitiveTypeAccess().getLessThanSignKeyword_2_0());
			}
			(
				(
					{
						newCompositeNode(grammarAccess.getReturnPrimitiveTypeAccess().getConstraintRuleConstraintRuleParserRuleCall_2_1_0());
					}
					lv_constraintRule_3_0=ruleConstraintRule
					{
						if ($current==null) {
							$current = createModelElementForParent(grammarAccess.getReturnPrimitiveTypeRule());
						}
						set(
							$current,
							"constraintRule",
							lv_constraintRule_3_0,
							"org.eclipse.vorto.editor.datatype.Datatype.ConstraintRule");
						afterParserOrEnumRuleCall();
					}
				)
			)
			otherlv_4='>'
			{
				newLeafNode(otherlv_4, grammarAccess.getReturnPrimitiveTypeAccess().getGreaterThanSignKeyword_2_2());
			}
		)?
	)
;

// Entry rule entryRulePrimitiveParam
entryRulePrimitiveParam returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getPrimitiveParamRule()); }
	iv_rulePrimitiveParam=rulePrimitiveParam
	{ $current=$iv_rulePrimitiveParam.current; }
	EOF;

// Rule PrimitiveParam
rulePrimitiveParam returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			(
				lv_multiplicity_0_0='multiple'
				{
					newLeafNode(lv_multiplicity_0_0, grammarAccess.getPrimitiveParamAccess().getMultiplicityMultipleKeyword_0_0());
				}
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getPrimitiveParamRule());
					}
					setWithLastConsumed($current, "multiplicity", true, "multiple");
				}
			)
		)?
		(
			(
				lv_name_1_0=RULE_ID
				{
					newLeafNode(lv_name_1_0, grammarAccess.getPrimitiveParamAccess().getNameIDTerminalRuleCall_1_0());
				}
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getPrimitiveParamRule());
					}
					setWithLastConsumed(
						$current,
						"name",
						lv_name_1_0,
						"org.eclipse.xtext.common.Terminals.ID");
				}
			)
		)
		otherlv_2='as'
		{
			newLeafNode(otherlv_2, grammarAccess.getPrimitiveParamAccess().getAsKeyword_2());
		}
		(
			(
				{
					newCompositeNode(grammarAccess.getPrimitiveParamAccess().getTypePrimitiveTypeEnumRuleCall_3_0());
				}
				lv_type_3_0=rulePrimitiveType
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getPrimitiveParamRule());
					}
					set(
						$current,
						"type",
						lv_type_3_0,
						"org.eclipse.vorto.editor.datatype.Datatype.PrimitiveType");
					afterParserOrEnumRuleCall();
				}
			)
		)
		(
			otherlv_4='<'
			{
				newLeafNode(otherlv_4, grammarAccess.getPrimitiveParamAccess().getLessThanSignKeyword_4_0());
			}
			(
				(
					{
						newCompositeNode(grammarAccess.getPrimitiveParamAccess().getConstraintRuleConstraintRuleParserRuleCall_4_1_0());
					}
					lv_constraintRule_5_0=ruleConstraintRule
					{
						if ($current==null) {
							$current = createModelElementForParent(grammarAccess.getPrimitiveParamRule());
						}
						set(
							$current,
							"constraintRule",
							lv_constraintRule_5_0,
							"org.eclipse.vorto.editor.datatype.Datatype.ConstraintRule");
						afterParserOrEnumRuleCall();
					}
				)
			)
			otherlv_6='>'
			{
				newLeafNode(otherlv_6, grammarAccess.getPrimitiveParamAccess().getGreaterThanSignKeyword_4_2());
			}
		)?
		(
			(
				lv_description_7_0=RULE_STRING
				{
					newLeafNode(lv_description_7_0, grammarAccess.getPrimitiveParamAccess().getDescriptionSTRINGTerminalRuleCall_5_0());
				}
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getPrimitiveParamRule());
					}
					setWithLastConsumed(
						$current,
						"description",
						lv_description_7_0,
						"org.eclipse.xtext.common.Terminals.STRING");
				}
			)
		)?
	)
;

// Entry rule entryRuleRefParam
entryRuleRefParam returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getRefParamRule()); }
	iv_ruleRefParam=ruleRefParam
	{ $current=$iv_ruleRefParam.current; }
	EOF;

// Rule RefParam
ruleRefParam returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			(
				lv_multiplicity_0_0='multiple'
				{
					newLeafNode(lv_multiplicity_0_0, grammarAccess.getRefParamAccess().getMultiplicityMultipleKeyword_0_0());
				}
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getRefParamRule());
					}
					setWithLastConsumed($current, "multiplicity", true, "multiple");
				}
			)
		)?
		(
			(
				lv_name_1_0=RULE_ID
				{
					newLeafNode(lv_name_1_0, grammarAccess.getRefParamAccess().getNameIDTerminalRuleCall_1_0());
				}
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getRefParamRule());
					}
					setWithLastConsumed(
						$current,
						"name",
						lv_name_1_0,
						"org.eclipse.xtext.common.Terminals.ID");
				}
			)
		)
		otherlv_2='as'
		{
			newLeafNode(otherlv_2, grammarAccess.getRefParamAccess().getAsKeyword_2());
		}
		(
			(
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getRefParamRule());
					}
				}
				{
					newCompositeNode(grammarAccess.getRefParamAccess().getTypeTypeCrossReference_3_0());
				}
				ruleQualifiedName
				{
					afterParserOrEnumRuleCall();
				}
			)
		)
		(
			(
				lv_description_4_0=RULE_STRING
				{
					newLeafNode(lv_description_4_0, grammarAccess.getRefParamAccess().getDescriptionSTRINGTerminalRuleCall_4_0());
				}
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getRefParamRule());
					}
					setWithLastConsumed(
						$current,
						"description",
						lv_description_4_0,
						"org.eclipse.xtext.common.Terminals.STRING");
				}
			)
		)?
	)
;

// Entry rule entryRuleParam
entryRuleParam returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getParamRule()); }
	iv_ruleParam=ruleParam
	{ $current=$iv_ruleParam.current; }
	EOF;

// Rule Param
ruleParam returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		{
			newCompositeNode(grammarAccess.getParamAccess().getPrimitiveParamParserRuleCall_0());
		}
		this_PrimitiveParam_0=rulePrimitiveParam
		{
			$current = $this_PrimitiveParam_0.current;
			afterParserOrEnumRuleCall();
		}
		    |
		{
			newCompositeNode(grammarAccess.getParamAccess().getRefParamParserRuleCall_1());
		}
		this_RefParam_1=ruleRefParam
		{
			$current = $this_RefParam_1.current;
			afterParserOrEnumRuleCall();
		}
	)
;

// Entry rule entryRuleEvent
entryRuleEvent returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getEventRule()); }
	iv_ruleEvent=ruleEvent
	{ $current=$iv_ruleEvent.current; }
	EOF;

// Rule Event
ruleEvent returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			(
				lv_name_0_0=RULE_ID
				{
					newLeafNode(lv_name_0_0, grammarAccess.getEventAccess().getNameIDTerminalRuleCall_0_0());
				}
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getEventRule());
					}
					setWithLastConsumed(
						$current,
						"name",
						lv_name_0_0,
						"org.eclipse.xtext.common.Terminals.ID");
				}
			)
		)
		otherlv_1='{'
		{
			newLeafNode(otherlv_1, grammarAccess.getEventAccess().getLeftCurlyBracketKeyword_1());
		}
		(
			(
				{
					newCompositeNode(grammarAccess.getEventAccess().getPropertiesPropertyParserRuleCall_2_0());
				}
				lv_properties_2_0=ruleProperty
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getEventRule());
					}
					add(
						$current,
						"properties",
						lv_properties_2_0,
						"org.eclipse.vorto.editor.datatype.Datatype.Property");
					afterParserOrEnumRuleCall();
				}
			)
		)*
		otherlv_3='}'
		{
			newLeafNode(otherlv_3, grammarAccess.getEventAccess().getRightCurlyBracketKeyword_3());
		}
	)
;

// Entry rule entryRuleCATEGORY
entryRuleCATEGORY returns [String current=null]:
	{ newCompositeNode(grammarAccess.getCATEGORYRule()); }
	iv_ruleCATEGORY=ruleCATEGORY
	{ $current=$iv_ruleCATEGORY.current.getText(); }
	EOF;

// Rule CATEGORY
ruleCATEGORY returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		this_ID_0=RULE_ID
		{
			$current.merge(this_ID_0);
		}
		{
			newLeafNode(this_ID_0, grammarAccess.getCATEGORYAccess().getIDTerminalRuleCall_0());
		}
		(
			kw='/'
			{
				$current.merge(kw);
				newLeafNode(kw, grammarAccess.getCATEGORYAccess().getSolidusKeyword_1_0());
			}
			this_ID_2=RULE_ID
			{
				$current.merge(this_ID_2);
			}
			{
				newLeafNode(this_ID_2, grammarAccess.getCATEGORYAccess().getIDTerminalRuleCall_1_1());
			}
		)*
	)
;

// Entry rule entryRuleModelReference
entryRuleModelReference returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getModelReferenceRule()); }
	iv_ruleModelReference=ruleModelReference
	{ $current=$iv_ruleModelReference.current; }
	EOF;

// Rule ModelReference
ruleModelReference returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		otherlv_0='using'
		{
			newLeafNode(otherlv_0, grammarAccess.getModelReferenceAccess().getUsingKeyword_0());
		}
		(
			(
				{
					newCompositeNode(grammarAccess.getModelReferenceAccess().getImportedNamespaceQualifiedNameParserRuleCall_1_0());
				}
				lv_importedNamespace_1_0=ruleQualifiedName
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getModelReferenceRule());
					}
					set(
						$current,
						"importedNamespace",
						lv_importedNamespace_1_0,
						"org.eclipse.vorto.editor.datatype.Datatype.QualifiedName");
					afterParserOrEnumRuleCall();
				}
			)
		)
		otherlv_2=';'
		{
			newLeafNode(otherlv_2, grammarAccess.getModelReferenceAccess().getSemicolonKeyword_2());
		}
		(
			(
				lv_version_3_0=RULE_VERSION
				{
					newLeafNode(lv_version_3_0, grammarAccess.getModelReferenceAccess().getVersionVERSIONTerminalRuleCall_3_0());
				}
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getModelReferenceRule());
					}
					setWithLastConsumed(
						$current,
						"version",
						lv_version_3_0,
						"org.eclipse.vorto.editor.datatype.Datatype.VERSION");
				}
			)
		)
	)
;

// Entry rule entryRuleQualifiedName
entryRuleQualifiedName returns [String current=null]:
	{ newCompositeNode(grammarAccess.getQualifiedNameRule()); }
	iv_ruleQualifiedName=ruleQualifiedName
	{ $current=$iv_ruleQualifiedName.current.getText(); }
	EOF;

// Rule QualifiedName
ruleQualifiedName returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		this_ID_0=RULE_ID
		{
			$current.merge(this_ID_0);
		}
		{
			newLeafNode(this_ID_0, grammarAccess.getQualifiedNameAccess().getIDTerminalRuleCall_0());
		}
		(
			kw='.'
			{
				$current.merge(kw);
				newLeafNode(kw, grammarAccess.getQualifiedNameAccess().getFullStopKeyword_1_0());
			}
			this_ID_2=RULE_ID
			{
				$current.merge(this_ID_2);
			}
			{
				newLeafNode(this_ID_2, grammarAccess.getQualifiedNameAccess().getIDTerminalRuleCall_1_1());
			}
		)*
	)
;

// Entry rule entryRuleType
entryRuleType returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getTypeRule()); }
	iv_ruleType=ruleType
	{ $current=$iv_ruleType.current; }
	EOF;

// Rule Type
ruleType returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		{
			newCompositeNode(grammarAccess.getTypeAccess().getEntityParserRuleCall_0());
		}
		this_Entity_0=ruleEntity
		{
			$current = $this_Entity_0.current;
			afterParserOrEnumRuleCall();
		}
		    |
		{
			newCompositeNode(grammarAccess.getTypeAccess().getEnumParserRuleCall_1());
		}
		this_Enum_1=ruleEnum
		{
			$current = $this_Enum_1.current;
			afterParserOrEnumRuleCall();
		}
	)
;

// Entry rule entryRuleEntity
entryRuleEntity returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getEntityRule()); }
	iv_ruleEntity=ruleEntity
	{ $current=$iv_ruleEntity.current; }
	EOF;

// Rule Entity
ruleEntity returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		otherlv_0='namespace'
		{
			newLeafNode(otherlv_0, grammarAccess.getEntityAccess().getNamespaceKeyword_0());
		}
		(
			(
				{
					newCompositeNode(grammarAccess.getEntityAccess().getNamespaceQualifiedNameParserRuleCall_1_0());
				}
				lv_namespace_1_0=ruleQualifiedName
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getEntityRule());
					}
					set(
						$current,
						"namespace",
						lv_namespace_1_0,
						"org.eclipse.vorto.editor.datatype.Datatype.QualifiedName");
					afterParserOrEnumRuleCall();
				}
			)
		)
		otherlv_2='version'
		{
			newLeafNode(otherlv_2, grammarAccess.getEntityAccess().getVersionKeyword_2());
		}
		(
			(
				lv_version_3_0=RULE_VERSION
				{
					newLeafNode(lv_version_3_0, grammarAccess.getEntityAccess().getVersionVERSIONTerminalRuleCall_3_0());
				}
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getEntityRule());
					}
					setWithLastConsumed(
						$current,
						"version",
						lv_version_3_0,
						"org.eclipse.vorto.editor.datatype.Datatype.VERSION");
				}
			)
		)
		(
			otherlv_4='displayname'
			{
				newLeafNode(otherlv_4, grammarAccess.getEntityAccess().getDisplaynameKeyword_4_0());
			}
			(
				(
					lv_displayname_5_0=RULE_STRING
					{
						newLeafNode(lv_displayname_5_0, grammarAccess.getEntityAccess().getDisplaynameSTRINGTerminalRuleCall_4_1_0());
					}
					{
						if ($current==null) {
							$current = createModelElement(grammarAccess.getEntityRule());
						}
						setWithLastConsumed(
							$current,
							"displayname",
							lv_displayname_5_0,
							"org.eclipse.xtext.common.Terminals.STRING");
					}
				)
			)
		)?
		(
			otherlv_6='description'
			{
				newLeafNode(otherlv_6, grammarAccess.getEntityAccess().getDescriptionKeyword_5_0());
			}
			(
				(
					lv_description_7_0=RULE_STRING
					{
						newLeafNode(lv_description_7_0, grammarAccess.getEntityAccess().getDescriptionSTRINGTerminalRuleCall_5_1_0());
					}
					{
						if ($current==null) {
							$current = createModelElement(grammarAccess.getEntityRule());
						}
						setWithLastConsumed(
							$current,
							"description",
							lv_description_7_0,
							"org.eclipse.xtext.common.Terminals.STRING");
					}
				)
			)
		)?
		(
			otherlv_8='category'
			{
				newLeafNode(otherlv_8, grammarAccess.getEntityAccess().getCategoryKeyword_6_0());
			}
			(
				(
					{
						newCompositeNode(grammarAccess.getEntityAccess().getCategoryCATEGORYParserRuleCall_6_1_0());
					}
					lv_category_9_0=ruleCATEGORY
					{
						if ($current==null) {
							$current = createModelElementForParent(grammarAccess.getEntityRule());
						}
						set(
							$current,
							"category",
							lv_category_9_0,
							"org.eclipse.vorto.editor.functionblock.Functionblock.CATEGORY");
						afterParserOrEnumRuleCall();
					}
				)
			)
		)?
		(
			(
				{
					newCompositeNode(grammarAccess.getEntityAccess().getReferencesModelReferenceParserRuleCall_7_0());
				}
				lv_references_10_0=ruleModelReference
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getEntityRule());
					}
					add(
						$current,
						"references",
						lv_references_10_0,
						"org.eclipse.vorto.editor.datatype.Datatype.ModelReference");
					afterParserOrEnumRuleCall();
				}
			)
		)*
		otherlv_11='entity'
		{
			newLeafNode(otherlv_11, grammarAccess.getEntityAccess().getEntityKeyword_8());
		}
		(
			(
				lv_name_12_0=RULE_ID
				{
					newLeafNode(lv_name_12_0, grammarAccess.getEntityAccess().getNameIDTerminalRuleCall_9_0());
				}
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getEntityRule());
					}
					setWithLastConsumed(
						$current,
						"name",
						lv_name_12_0,
						"org.eclipse.xtext.common.Terminals.ID");
				}
			)
		)
		(
			otherlv_13='extends'
			{
				newLeafNode(otherlv_13, grammarAccess.getEntityAccess().getExtendsKeyword_10_0());
			}
			(
				(
					{
						if ($current==null) {
							$current = createModelElement(grammarAccess.getEntityRule());
						}
					}
					{
						newCompositeNode(grammarAccess.getEntityAccess().getSuperTypeEntityCrossReference_10_1_0());
					}
					ruleQualifiedName
					{
						afterParserOrEnumRuleCall();
					}
				)
			)
		)?
		otherlv_15='{'
		{
			newLeafNode(otherlv_15, grammarAccess.getEntityAccess().getLeftCurlyBracketKeyword_11());
		}
		(
			(
				{
					newCompositeNode(grammarAccess.getEntityAccess().getPropertiesPropertyParserRuleCall_12_0());
				}
				lv_properties_16_0=ruleProperty
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getEntityRule());
					}
					add(
						$current,
						"properties",
						lv_properties_16_0,
						"org.eclipse.vorto.editor.datatype.Datatype.Property");
					afterParserOrEnumRuleCall();
				}
			)
		)*
		otherlv_17='}'
		{
			newLeafNode(otherlv_17, grammarAccess.getEntityAccess().getRightCurlyBracketKeyword_13());
		}
	)
;

// Entry rule entryRuleEnum
entryRuleEnum returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getEnumRule()); }
	iv_ruleEnum=ruleEnum
	{ $current=$iv_ruleEnum.current; }
	EOF;

// Rule Enum
ruleEnum returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		otherlv_0='namespace'
		{
			newLeafNode(otherlv_0, grammarAccess.getEnumAccess().getNamespaceKeyword_0());
		}
		(
			(
				{
					newCompositeNode(grammarAccess.getEnumAccess().getNamespaceQualifiedNameParserRuleCall_1_0());
				}
				lv_namespace_1_0=ruleQualifiedName
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getEnumRule());
					}
					set(
						$current,
						"namespace",
						lv_namespace_1_0,
						"org.eclipse.vorto.editor.datatype.Datatype.QualifiedName");
					afterParserOrEnumRuleCall();
				}
			)
		)
		otherlv_2='version'
		{
			newLeafNode(otherlv_2, grammarAccess.getEnumAccess().getVersionKeyword_2());
		}
		(
			(
				lv_version_3_0=RULE_VERSION
				{
					newLeafNode(lv_version_3_0, grammarAccess.getEnumAccess().getVersionVERSIONTerminalRuleCall_3_0());
				}
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getEnumRule());
					}
					setWithLastConsumed(
						$current,
						"version",
						lv_version_3_0,
						"org.eclipse.vorto.editor.datatype.Datatype.VERSION");
				}
			)
		)
		(
			otherlv_4='displayname'
			{
				newLeafNode(otherlv_4, grammarAccess.getEnumAccess().getDisplaynameKeyword_4_0());
			}
			(
				(
					lv_displayname_5_0=RULE_STRING
					{
						newLeafNode(lv_displayname_5_0, grammarAccess.getEnumAccess().getDisplaynameSTRINGTerminalRuleCall_4_1_0());
					}
					{
						if ($current==null) {
							$current = createModelElement(grammarAccess.getEnumRule());
						}
						setWithLastConsumed(
							$current,
							"displayname",
							lv_displayname_5_0,
							"org.eclipse.xtext.common.Terminals.STRING");
					}
				)
			)
		)?
		(
			otherlv_6='description'
			{
				newLeafNode(otherlv_6, grammarAccess.getEnumAccess().getDescriptionKeyword_5_0());
			}
			(
				(
					lv_description_7_0=RULE_STRING
					{
						newLeafNode(lv_description_7_0, grammarAccess.getEnumAccess().getDescriptionSTRINGTerminalRuleCall_5_1_0());
					}
					{
						if ($current==null) {
							$current = createModelElement(grammarAccess.getEnumRule());
						}
						setWithLastConsumed(
							$current,
							"description",
							lv_description_7_0,
							"org.eclipse.xtext.common.Terminals.STRING");
					}
				)
			)
		)?
		(
			otherlv_8='category'
			{
				newLeafNode(otherlv_8, grammarAccess.getEnumAccess().getCategoryKeyword_6_0());
			}
			(
				(
					{
						newCompositeNode(grammarAccess.getEnumAccess().getCategoryCATEGORYParserRuleCall_6_1_0());
					}
					lv_category_9_0=ruleCATEGORY
					{
						if ($current==null) {
							$current = createModelElementForParent(grammarAccess.getEnumRule());
						}
						set(
							$current,
							"category",
							lv_category_9_0,
							"org.eclipse.vorto.editor.functionblock.Functionblock.CATEGORY");
						afterParserOrEnumRuleCall();
					}
				)
			)
		)?
		(
			(
				{
					newCompositeNode(grammarAccess.getEnumAccess().getReferencesModelReferenceParserRuleCall_7_0());
				}
				lv_references_10_0=ruleModelReference
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getEnumRule());
					}
					add(
						$current,
						"references",
						lv_references_10_0,
						"org.eclipse.vorto.editor.datatype.Datatype.ModelReference");
					afterParserOrEnumRuleCall();
				}
			)
		)*
		otherlv_11='enum'
		{
			newLeafNode(otherlv_11, grammarAccess.getEnumAccess().getEnumKeyword_8());
		}
		(
			(
				lv_name_12_0=RULE_ID
				{
					newLeafNode(lv_name_12_0, grammarAccess.getEnumAccess().getNameIDTerminalRuleCall_9_0());
				}
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getEnumRule());
					}
					setWithLastConsumed(
						$current,
						"name",
						lv_name_12_0,
						"org.eclipse.xtext.common.Terminals.ID");
				}
			)
		)
		otherlv_13='{'
		{
			newLeafNode(otherlv_13, grammarAccess.getEnumAccess().getLeftCurlyBracketKeyword_10());
		}
		(
			(
				(
					{
						newCompositeNode(grammarAccess.getEnumAccess().getEnumsEnumLiteralParserRuleCall_11_0_0());
					}
					lv_enums_14_0=ruleEnumLiteral
					{
						if ($current==null) {
							$current = createModelElementForParent(grammarAccess.getEnumRule());
						}
						add(
							$current,
							"enums",
							lv_enums_14_0,
							"org.eclipse.vorto.editor.datatype.Datatype.EnumLiteral");
						afterParserOrEnumRuleCall();
					}
				)
			)
			(
				otherlv_15=','
				{
					newLeafNode(otherlv_15, grammarAccess.getEnumAccess().getCommaKeyword_11_1_0());
				}
				(
					(
						{
							newCompositeNode(grammarAccess.getEnumAccess().getEnumsEnumLiteralParserRuleCall_11_1_1_0());
						}
						lv_enums_16_0=ruleEnumLiteral
						{
							if ($current==null) {
								$current = createModelElementForParent(grammarAccess.getEnumRule());
							}
							add(
								$current,
								"enums",
								lv_enums_16_0,
								"org.eclipse.vorto.editor.datatype.Datatype.EnumLiteral");
							afterParserOrEnumRuleCall();
						}
					)
				)
			)*
		)?
		otherlv_17='}'
		{
			newLeafNode(otherlv_17, grammarAccess.getEnumAccess().getRightCurlyBracketKeyword_12());
		}
	)
;

// Entry rule entryRuleEnumLiteral
entryRuleEnumLiteral returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getEnumLiteralRule()); }
	iv_ruleEnumLiteral=ruleEnumLiteral
	{ $current=$iv_ruleEnumLiteral.current; }
	EOF;

// Rule EnumLiteral
ruleEnumLiteral returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			(
				lv_name_0_0=RULE_ID
				{
					newLeafNode(lv_name_0_0, grammarAccess.getEnumLiteralAccess().getNameIDTerminalRuleCall_0_0());
				}
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getEnumLiteralRule());
					}
					setWithLastConsumed(
						$current,
						"name",
						lv_name_0_0,
						"org.eclipse.xtext.common.Terminals.ID");
				}
			)
		)
		(
			(
				lv_description_1_0=RULE_STRING
				{
					newLeafNode(lv_description_1_0, grammarAccess.getEnumLiteralAccess().getDescriptionSTRINGTerminalRuleCall_1_0());
				}
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getEnumLiteralRule());
					}
					setWithLastConsumed(
						$current,
						"description",
						lv_description_1_0,
						"org.eclipse.xtext.common.Terminals.STRING");
				}
			)
		)?
	)
;

// Entry rule entryRuleProperty
entryRuleProperty returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getPropertyRule()); }
	iv_ruleProperty=ruleProperty
	{ $current=$iv_ruleProperty.current; }
	EOF;

// Rule Property
ruleProperty returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			(
				{
					newCompositeNode(grammarAccess.getPropertyAccess().getPresencePresenceParserRuleCall_0_0());
				}
				lv_presence_0_0=rulePresence
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getPropertyRule());
					}
					set(
						$current,
						"presence",
						lv_presence_0_0,
						"org.eclipse.vorto.editor.datatype.Datatype.Presence");
					afterParserOrEnumRuleCall();
				}
			)
		)?
		(
			(
				lv_multiplicity_1_0='multiple'
				{
					newLeafNode(lv_multiplicity_1_0, grammarAccess.getPropertyAccess().getMultiplicityMultipleKeyword_1_0());
				}
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getPropertyRule());
					}
					setWithLastConsumed($current, "multiplicity", true, "multiple");
				}
			)
		)?
		(
			(
				lv_name_2_0=RULE_ID
				{
					newLeafNode(lv_name_2_0, grammarAccess.getPropertyAccess().getNameIDTerminalRuleCall_2_0());
				}
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getPropertyRule());
					}
					setWithLastConsumed(
						$current,
						"name",
						lv_name_2_0,
						"org.eclipse.xtext.common.Terminals.ID");
				}
			)
		)
		otherlv_3='as'
		{
			newLeafNode(otherlv_3, grammarAccess.getPropertyAccess().getAsKeyword_3());
		}
		(
			(
				{
					newCompositeNode(grammarAccess.getPropertyAccess().getTypePropertyTypeParserRuleCall_4_0());
				}
				lv_type_4_0=rulePropertyType
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getPropertyRule());
					}
					set(
						$current,
						"type",
						lv_type_4_0,
						"org.eclipse.vorto.editor.datatype.Datatype.PropertyType");
					afterParserOrEnumRuleCall();
				}
			)
		)
		(
			otherlv_5='with'
			{
				newLeafNode(otherlv_5, grammarAccess.getPropertyAccess().getWithKeyword_5_0());
			}
			otherlv_6='{'
			{
				newLeafNode(otherlv_6, grammarAccess.getPropertyAccess().getLeftCurlyBracketKeyword_5_1());
			}
			(
				(
					{
						newCompositeNode(grammarAccess.getPropertyAccess().getPropertyAttributesPropertyAttributeParserRuleCall_5_2_0());
					}
					lv_propertyAttributes_7_0=rulePropertyAttribute
					{
						if ($current==null) {
							$current = createModelElementForParent(grammarAccess.getPropertyRule());
						}
						add(
							$current,
							"propertyAttributes",
							lv_propertyAttributes_7_0,
							"org.eclipse.vorto.editor.datatype.Datatype.PropertyAttribute");
						afterParserOrEnumRuleCall();
					}
				)
			)
			(
				otherlv_8=','
				{
					newLeafNode(otherlv_8, grammarAccess.getPropertyAccess().getCommaKeyword_5_3_0());
				}
				(
					(
						{
							newCompositeNode(grammarAccess.getPropertyAccess().getPropertyAttributesPropertyAttributeParserRuleCall_5_3_1_0());
						}
						lv_propertyAttributes_9_0=rulePropertyAttribute
						{
							if ($current==null) {
								$current = createModelElementForParent(grammarAccess.getPropertyRule());
							}
							add(
								$current,
								"propertyAttributes",
								lv_propertyAttributes_9_0,
								"org.eclipse.vorto.editor.datatype.Datatype.PropertyAttribute");
							afterParserOrEnumRuleCall();
						}
					)
				)
			)*
			otherlv_10='}'
			{
				newLeafNode(otherlv_10, grammarAccess.getPropertyAccess().getRightCurlyBracketKeyword_5_4());
			}
		)?
		(
			otherlv_11='<'
			{
				newLeafNode(otherlv_11, grammarAccess.getPropertyAccess().getLessThanSignKeyword_6_0());
			}
			(
				(
					{
						newCompositeNode(grammarAccess.getPropertyAccess().getConstraintRuleConstraintRuleParserRuleCall_6_1_0());
					}
					lv_constraintRule_12_0=ruleConstraintRule
					{
						if ($current==null) {
							$current = createModelElementForParent(grammarAccess.getPropertyRule());
						}
						set(
							$current,
							"constraintRule",
							lv_constraintRule_12_0,
							"org.eclipse.vorto.editor.datatype.Datatype.ConstraintRule");
						afterParserOrEnumRuleCall();
					}
				)
			)
			otherlv_13='>'
			{
				newLeafNode(otherlv_13, grammarAccess.getPropertyAccess().getGreaterThanSignKeyword_6_2());
			}
		)?
		(
			(
				lv_description_14_0=RULE_STRING
				{
					newLeafNode(lv_description_14_0, grammarAccess.getPropertyAccess().getDescriptionSTRINGTerminalRuleCall_7_0());
				}
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getPropertyRule());
					}
					setWithLastConsumed(
						$current,
						"description",
						lv_description_14_0,
						"org.eclipse.xtext.common.Terminals.STRING");
				}
			)
		)?
	)
;

// Entry rule entryRuleConstraintRule
entryRuleConstraintRule returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getConstraintRuleRule()); }
	iv_ruleConstraintRule=ruleConstraintRule
	{ $current=$iv_ruleConstraintRule.current; }
	EOF;

// Rule ConstraintRule
ruleConstraintRule returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			{
				$current = forceCreateModelElement(
					grammarAccess.getConstraintRuleAccess().getConstraintRuleAction_0(),
					$current);
			}
		)
		(
			(
				(
					{
						newCompositeNode(grammarAccess.getConstraintRuleAccess().getConstraintsConstraintParserRuleCall_1_0_0());
					}
					lv_Constraints_1_0=ruleConstraint
					{
						if ($current==null) {
							$current = createModelElementForParent(grammarAccess.getConstraintRuleRule());
						}
						add(
							$current,
							"Constraints",
							lv_Constraints_1_0,
							"org.eclipse.vorto.editor.datatype.Datatype.Constraint");
						afterParserOrEnumRuleCall();
					}
				)
			)
			(
				otherlv_2=','
				{
					newLeafNode(otherlv_2, grammarAccess.getConstraintRuleAccess().getCommaKeyword_1_1_0());
				}
				(
					(
						{
							newCompositeNode(grammarAccess.getConstraintRuleAccess().getConstraintsConstraintParserRuleCall_1_1_1_0());
						}
						lv_Constraints_3_0=ruleConstraint
						{
							if ($current==null) {
								$current = createModelElementForParent(grammarAccess.getConstraintRuleRule());
							}
							add(
								$current,
								"Constraints",
								lv_Constraints_3_0,
								"org.eclipse.vorto.editor.datatype.Datatype.Constraint");
							afterParserOrEnumRuleCall();
						}
					)
				)
			)*
		)?
	)
;

// Entry rule entryRuleEnumLiteralName
entryRuleEnumLiteralName returns [String current=null]:
	{ newCompositeNode(grammarAccess.getEnumLiteralNameRule()); }
	iv_ruleEnumLiteralName=ruleEnumLiteralName
	{ $current=$iv_ruleEnumLiteralName.current.getText(); }
	EOF;

// Rule EnumLiteralName
ruleEnumLiteralName returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		this_ID_0=RULE_ID
		{
			$current.merge(this_ID_0);
		}
		{
			newLeafNode(this_ID_0, grammarAccess.getEnumLiteralNameAccess().getIDTerminalRuleCall_0());
		}
		kw='.'
		{
			$current.merge(kw);
			newLeafNode(kw, grammarAccess.getEnumLiteralNameAccess().getFullStopKeyword_1());
		}
		this_ID_2=RULE_ID
		{
			$current.merge(this_ID_2);
		}
		{
			newLeafNode(this_ID_2, grammarAccess.getEnumLiteralNameAccess().getIDTerminalRuleCall_2());
		}
	)
;

// Entry rule entryRulePropertyAttribute
entryRulePropertyAttribute returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getPropertyAttributeRule()); }
	iv_rulePropertyAttribute=rulePropertyAttribute
	{ $current=$iv_rulePropertyAttribute.current; }
	EOF;

// Rule PropertyAttribute
rulePropertyAttribute returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		{
			newCompositeNode(grammarAccess.getPropertyAttributeAccess().getBooleanPropertyAttributeParserRuleCall_0());
		}
		this_BooleanPropertyAttribute_0=ruleBooleanPropertyAttribute
		{
			$current = $this_BooleanPropertyAttribute_0.current;
			afterParserOrEnumRuleCall();
		}
		    |
		{
			newCompositeNode(grammarAccess.getPropertyAttributeAccess().getEnumLiteralPropertyAttributeParserRuleCall_1());
		}
		this_EnumLiteralPropertyAttribute_1=ruleEnumLiteralPropertyAttribute
		{
			$current = $this_EnumLiteralPropertyAttribute_1.current;
			afterParserOrEnumRuleCall();
		}
	)
;

// Entry rule entryRuleBooleanPropertyAttribute
entryRuleBooleanPropertyAttribute returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getBooleanPropertyAttributeRule()); }
	iv_ruleBooleanPropertyAttribute=ruleBooleanPropertyAttribute
	{ $current=$iv_ruleBooleanPropertyAttribute.current; }
	EOF;

// Rule BooleanPropertyAttribute
ruleBooleanPropertyAttribute returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			(
				{
					newCompositeNode(grammarAccess.getBooleanPropertyAttributeAccess().getTypeBooleanPropertyAttributeTypeEnumRuleCall_0_0());
				}
				lv_type_0_0=ruleBooleanPropertyAttributeType
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getBooleanPropertyAttributeRule());
					}
					set(
						$current,
						"type",
						lv_type_0_0,
						"org.eclipse.vorto.editor.datatype.Datatype.BooleanPropertyAttributeType");
					afterParserOrEnumRuleCall();
				}
			)
		)
		otherlv_1=':'
		{
			newLeafNode(otherlv_1, grammarAccess.getBooleanPropertyAttributeAccess().getColonKeyword_1());
		}
		(
			(
				(
					lv_value_2_0='true'
					{
						newLeafNode(lv_value_2_0, grammarAccess.getBooleanPropertyAttributeAccess().getValueTrueKeyword_2_0_0());
					}
					{
						if ($current==null) {
							$current = createModelElement(grammarAccess.getBooleanPropertyAttributeRule());
						}
						setWithLastConsumed($current, "value", true, "true");
					}
				)
			)
			    |
			otherlv_3='false'
			{
				newLeafNode(otherlv_3, grammarAccess.getBooleanPropertyAttributeAccess().getFalseKeyword_2_1());
			}
		)
	)
;

// Entry rule entryRuleEnumLiteralPropertyAttribute
entryRuleEnumLiteralPropertyAttribute returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getEnumLiteralPropertyAttributeRule()); }
	iv_ruleEnumLiteralPropertyAttribute=ruleEnumLiteralPropertyAttribute
	{ $current=$iv_ruleEnumLiteralPropertyAttribute.current; }
	EOF;

// Rule EnumLiteralPropertyAttribute
ruleEnumLiteralPropertyAttribute returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			(
				{
					newCompositeNode(grammarAccess.getEnumLiteralPropertyAttributeAccess().getTypeEnumLiteralPropertyAttributeTypeEnumRuleCall_0_0());
				}
				lv_type_0_0=ruleEnumLiteralPropertyAttributeType
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getEnumLiteralPropertyAttributeRule());
					}
					set(
						$current,
						"type",
						lv_type_0_0,
						"org.eclipse.vorto.editor.datatype.Datatype.EnumLiteralPropertyAttributeType");
					afterParserOrEnumRuleCall();
				}
			)
		)
		otherlv_1=':'
		{
			newLeafNode(otherlv_1, grammarAccess.getEnumLiteralPropertyAttributeAccess().getColonKeyword_1());
		}
		(
			(
				{
					if ($current==null) {
						$current = createModelElement(grammarAccess.getEnumLiteralPropertyAttributeRule());
					}
				}
				{
					newCompositeNode(grammarAccess.getEnumLiteralPropertyAttributeAccess().getValueEnumLiteralCrossReference_2_0());
				}
				ruleEnumLiteralName
				{
					afterParserOrEnumRuleCall();
				}
			)
		)
	)
;

// Entry rule entryRulePropertyType
entryRulePropertyType returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getPropertyTypeRule()); }
	iv_rulePropertyType=rulePropertyType
	{ $current=$iv_rulePropertyType.current; }
	EOF;

// Rule PropertyType
rulePropertyType returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		{
			newCompositeNode(grammarAccess.getPropertyTypeAccess().getObjectPropertyTypeParserRuleCall_0());
		}
		this_ObjectPropertyType_0=ruleObjectPropertyType
		{
			$current = $this_ObjectPropertyType_0.current;
			afterParserOrEnumRuleCall();
		}
		    |
		{
			newCompositeNode(grammarAccess.getPropertyTypeAccess().getPrimitivePropertyTypeParserRuleCall_1());
		}
		this_PrimitivePropertyType_1=rulePrimitivePropertyType
		{
			$current = $this_PrimitivePropertyType_1.current;
			afterParserOrEnumRuleCall();
		}
		    |
		{
			newCompositeNode(grammarAccess.getPropertyTypeAccess().getComplexPrimitivePropertyTypeParserRuleCall_2());
		}
		this_ComplexPrimitivePropertyType_2=ruleComplexPrimitivePropertyType
		{
			$current = $this_ComplexPrimitivePropertyType_2.current;
			afterParserOrEnumRuleCall();
		}
	)
;

// Entry rule entryRulePrimitivePropertyType
entryRulePrimitivePropertyType returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getPrimitivePropertyTypeRule()); }
	iv_rulePrimitivePropertyType=rulePrimitivePropertyType
	{ $current=$iv_rulePrimitivePropertyType.current; }
	EOF;

// Rule PrimitivePropertyType
rulePrimitivePropertyType returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			{
				newCompositeNode(grammarAccess.getPrimitivePropertyTypeAccess().getTypePrimitiveTypeEnumRuleCall_0());
			}
			lv_type_0_0=rulePrimitiveType
			{
				if ($current==null) {
					$current = createModelElementForParent(grammarAccess.getPrimitivePropertyTypeRule());
				}
				set(
					$current,
					"type",
					lv_type_0_0,
					"org.eclipse.vorto.editor.datatype.Datatype.PrimitiveType");
				afterParserOrEnumRuleCall();
			}
		)
	)
;

// Entry rule entryRuleObjectPropertyType
entryRuleObjectPropertyType returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getObjectPropertyTypeRule()); }
	iv_ruleObjectPropertyType=ruleObjectPropertyType
	{ $current=$iv_ruleObjectPropertyType.current; }
	EOF;

// Rule ObjectPropertyType
ruleObjectPropertyType returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			{
				if ($current==null) {
					$current = createModelElement(grammarAccess.getObjectPropertyTypeRule());
				}
			}
			{
				newCompositeNode(grammarAccess.getObjectPropertyTypeAccess().getTypeTypeCrossReference_0());
			}
			ruleQualifiedName
			{
				afterParserOrEnumRuleCall();
			}
		)
	)
;

// Entry rule entryRuleComplexPrimitivePropertyType
entryRuleComplexPrimitivePropertyType returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getComplexPrimitivePropertyTypeRule()); }
	iv_ruleComplexPrimitivePropertyType=ruleComplexPrimitivePropertyType
	{ $current=$iv_ruleComplexPrimitivePropertyType.current; }
	EOF;

// Rule ComplexPrimitivePropertyType
ruleComplexPrimitivePropertyType returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	{
		newCompositeNode(grammarAccess.getComplexPrimitivePropertyTypeAccess().getDictionaryPropertyTypeParserRuleCall());
	}
	this_DictionaryPropertyType_0=ruleDictionaryPropertyType
	{
		$current = $this_DictionaryPropertyType_0.current;
		afterParserOrEnumRuleCall();
	}
;

// Entry rule entryRuleDictionaryPropertyType
entryRuleDictionaryPropertyType returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getDictionaryPropertyTypeRule()); }
	iv_ruleDictionaryPropertyType=ruleDictionaryPropertyType
	{ $current=$iv_ruleDictionaryPropertyType.current; }
	EOF;

// Rule DictionaryPropertyType
ruleDictionaryPropertyType returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			{
				$current = forceCreateModelElement(
					grammarAccess.getDictionaryPropertyTypeAccess().getDictionaryPropertyTypeAction_0(),
					$current);
			}
		)
		otherlv_1='Dictionary'
		{
			newLeafNode(otherlv_1, grammarAccess.getDictionaryPropertyTypeAccess().getDictionaryKeyword_1());
		}
		(
			otherlv_2='['
			{
				newLeafNode(otherlv_2, grammarAccess.getDictionaryPropertyTypeAccess().getLeftSquareBracketKeyword_2_0());
			}
			(
				(
					{
						newCompositeNode(grammarAccess.getDictionaryPropertyTypeAccess().getKeyTypePropertyTypeParserRuleCall_2_1_0());
					}
					lv_keyType_3_0=rulePropertyType
					{
						if ($current==null) {
							$current = createModelElementForParent(grammarAccess.getDictionaryPropertyTypeRule());
						}
						set(
							$current,
							"keyType",
							lv_keyType_3_0,
							"org.eclipse.vorto.editor.datatype.Datatype.PropertyType");
						afterParserOrEnumRuleCall();
					}
				)
			)
			otherlv_4=','
			{
				newLeafNode(otherlv_4, grammarAccess.getDictionaryPropertyTypeAccess().getCommaKeyword_2_2());
			}
			(
				(
					{
						newCompositeNode(grammarAccess.getDictionaryPropertyTypeAccess().getValueTypePropertyTypeParserRuleCall_2_3_0());
					}
					lv_valueType_5_0=rulePropertyType
					{
						if ($current==null) {
							$current = createModelElementForParent(grammarAccess.getDictionaryPropertyTypeRule());
						}
						set(
							$current,
							"valueType",
							lv_valueType_5_0,
							"org.eclipse.vorto.editor.datatype.Datatype.PropertyType");
						afterParserOrEnumRuleCall();
					}
				)
			)
			otherlv_6=']'
			{
				newLeafNode(otherlv_6, grammarAccess.getDictionaryPropertyTypeAccess().getRightSquareBracketKeyword_2_4());
			}
		)?
	)
;

// Entry rule entryRulePresence
entryRulePresence returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getPresenceRule()); }
	iv_rulePresence=rulePresence
	{ $current=$iv_rulePresence.current; }
	EOF;

// Rule Presence
rulePresence returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			{
				$current = forceCreateModelElement(
					grammarAccess.getPresenceAccess().getPresenceAction_0(),
					$current);
			}
		)
		(
			(
				(
					lv_mandatory_1_0='mandatory'
					{
						newLeafNode(lv_mandatory_1_0, grammarAccess.getPresenceAccess().getMandatoryMandatoryKeyword_1_0_0());
					}
					{
						if ($current==null) {
							$current = createModelElement(grammarAccess.getPresenceRule());
						}
						setWithLastConsumed($current, "mandatory", true, "mandatory");
					}
				)
			)
			    |
			otherlv_2='optional'
			{
				newLeafNode(otherlv_2, grammarAccess.getPresenceAccess().getOptionalKeyword_1_1());
			}
		)
	)
;

// Entry rule entryRuleConstraint
entryRuleConstraint returns [EObject current=null]:
	{ newCompositeNode(grammarAccess.getConstraintRule()); }
	iv_ruleConstraint=ruleConstraint
	{ $current=$iv_ruleConstraint.current; }
	EOF;

// Rule Constraint
ruleConstraint returns [EObject current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			(
				{
					newCompositeNode(grammarAccess.getConstraintAccess().getTypeConstraintIntervalTypeEnumRuleCall_0_0());
				}
				lv_type_0_0=ruleConstraintIntervalType
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getConstraintRule());
					}
					set(
						$current,
						"type",
						lv_type_0_0,
						"org.eclipse.vorto.editor.datatype.Datatype.ConstraintIntervalType");
					afterParserOrEnumRuleCall();
				}
			)
		)
		(
			(
				{
					newCompositeNode(grammarAccess.getConstraintAccess().getConstraintValuesIntervalTypeParserRuleCall_1_0());
				}
				lv_constraintValues_1_0=ruleIntervalType
				{
					if ($current==null) {
						$current = createModelElementForParent(grammarAccess.getConstraintRule());
					}
					set(
						$current,
						"constraintValues",
						lv_constraintValues_1_0,
						"org.eclipse.vorto.editor.datatype.Datatype.IntervalType");
					afterParserOrEnumRuleCall();
				}
			)
		)
	)
;

// Entry rule entryRuleIntervalType
entryRuleIntervalType returns [String current=null]:
	{ newCompositeNode(grammarAccess.getIntervalTypeRule()); }
	iv_ruleIntervalType=ruleIntervalType
	{ $current=$iv_ruleIntervalType.current.getText(); }
	EOF;

// Rule IntervalType
ruleIntervalType returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		this_INT_0=RULE_INT
		{
			$current.merge(this_INT_0);
		}
		{
			newLeafNode(this_INT_0, grammarAccess.getIntervalTypeAccess().getINTTerminalRuleCall_0());
		}
		    |
		this_SIGNEDINT_1=RULE_SIGNEDINT
		{
			$current.merge(this_SIGNEDINT_1);
		}
		{
			newLeafNode(this_SIGNEDINT_1, grammarAccess.getIntervalTypeAccess().getSIGNEDINTTerminalRuleCall_1());
		}
		    |
		this_FLOAT_2=RULE_FLOAT
		{
			$current.merge(this_FLOAT_2);
		}
		{
			newLeafNode(this_FLOAT_2, grammarAccess.getIntervalTypeAccess().getFLOATTerminalRuleCall_2());
		}
		    |
		this_DATETIME_3=RULE_DATETIME
		{
			$current.merge(this_DATETIME_3);
		}
		{
			newLeafNode(this_DATETIME_3, grammarAccess.getIntervalTypeAccess().getDATETIMETerminalRuleCall_3());
		}
		    |
		this_STRING_4=RULE_STRING
		{
			$current.merge(this_STRING_4);
		}
		{
			newLeafNode(this_STRING_4, grammarAccess.getIntervalTypeAccess().getSTRINGTerminalRuleCall_4());
		}
	)
;

// Rule BooleanPropertyAttributeType
ruleBooleanPropertyAttributeType returns [Enumerator current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			enumLiteral_0='readable'
			{
				$current = grammarAccess.getBooleanPropertyAttributeTypeAccess().getReadableEnumLiteralDeclaration_0().getEnumLiteral().getInstance();
				newLeafNode(enumLiteral_0, grammarAccess.getBooleanPropertyAttributeTypeAccess().getReadableEnumLiteralDeclaration_0());
			}
		)
		    |
		(
			enumLiteral_1='writable'
			{
				$current = grammarAccess.getBooleanPropertyAttributeTypeAccess().getWritableEnumLiteralDeclaration_1().getEnumLiteral().getInstance();
				newLeafNode(enumLiteral_1, grammarAccess.getBooleanPropertyAttributeTypeAccess().getWritableEnumLiteralDeclaration_1());
			}
		)
		    |
		(
			enumLiteral_2='eventable'
			{
				$current = grammarAccess.getBooleanPropertyAttributeTypeAccess().getEventableEnumLiteralDeclaration_2().getEnumLiteral().getInstance();
				newLeafNode(enumLiteral_2, grammarAccess.getBooleanPropertyAttributeTypeAccess().getEventableEnumLiteralDeclaration_2());
			}
		)
	)
;

// Rule EnumLiteralPropertyAttributeType
ruleEnumLiteralPropertyAttributeType returns [Enumerator current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		enumLiteral_0='measurementUnit'
		{
			$current = grammarAccess.getEnumLiteralPropertyAttributeTypeAccess().getMeasurementUnitEnumLiteralDeclaration().getEnumLiteral().getInstance();
			newLeafNode(enumLiteral_0, grammarAccess.getEnumLiteralPropertyAttributeTypeAccess().getMeasurementUnitEnumLiteralDeclaration());
		}
	)
;

// Rule PrimitiveType
rulePrimitiveType returns [Enumerator current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			enumLiteral_0='string'
			{
				$current = grammarAccess.getPrimitiveTypeAccess().getStringEnumLiteralDeclaration_0().getEnumLiteral().getInstance();
				newLeafNode(enumLiteral_0, grammarAccess.getPrimitiveTypeAccess().getStringEnumLiteralDeclaration_0());
			}
		)
		    |
		(
			enumLiteral_1='int'
			{
				$current = grammarAccess.getPrimitiveTypeAccess().getIntEnumLiteralDeclaration_1().getEnumLiteral().getInstance();
				newLeafNode(enumLiteral_1, grammarAccess.getPrimitiveTypeAccess().getIntEnumLiteralDeclaration_1());
			}
		)
		    |
		(
			enumLiteral_2='float'
			{
				$current = grammarAccess.getPrimitiveTypeAccess().getFloatEnumLiteralDeclaration_2().getEnumLiteral().getInstance();
				newLeafNode(enumLiteral_2, grammarAccess.getPrimitiveTypeAccess().getFloatEnumLiteralDeclaration_2());
			}
		)
		    |
		(
			enumLiteral_3='boolean'
			{
				$current = grammarAccess.getPrimitiveTypeAccess().getBooleanEnumLiteralDeclaration_3().getEnumLiteral().getInstance();
				newLeafNode(enumLiteral_3, grammarAccess.getPrimitiveTypeAccess().getBooleanEnumLiteralDeclaration_3());
			}
		)
		    |
		(
			enumLiteral_4='dateTime'
			{
				$current = grammarAccess.getPrimitiveTypeAccess().getDatetimeEnumLiteralDeclaration_4().getEnumLiteral().getInstance();
				newLeafNode(enumLiteral_4, grammarAccess.getPrimitiveTypeAccess().getDatetimeEnumLiteralDeclaration_4());
			}
		)
		    |
		(
			enumLiteral_5='double'
			{
				$current = grammarAccess.getPrimitiveTypeAccess().getDoubleEnumLiteralDeclaration_5().getEnumLiteral().getInstance();
				newLeafNode(enumLiteral_5, grammarAccess.getPrimitiveTypeAccess().getDoubleEnumLiteralDeclaration_5());
			}
		)
		    |
		(
			enumLiteral_6='long'
			{
				$current = grammarAccess.getPrimitiveTypeAccess().getLongEnumLiteralDeclaration_6().getEnumLiteral().getInstance();
				newLeafNode(enumLiteral_6, grammarAccess.getPrimitiveTypeAccess().getLongEnumLiteralDeclaration_6());
			}
		)
		    |
		(
			enumLiteral_7='short'
			{
				$current = grammarAccess.getPrimitiveTypeAccess().getShortEnumLiteralDeclaration_7().getEnumLiteral().getInstance();
				newLeafNode(enumLiteral_7, grammarAccess.getPrimitiveTypeAccess().getShortEnumLiteralDeclaration_7());
			}
		)
		    |
		(
			enumLiteral_8='base64Binary'
			{
				$current = grammarAccess.getPrimitiveTypeAccess().getBase64BinaryEnumLiteralDeclaration_8().getEnumLiteral().getInstance();
				newLeafNode(enumLiteral_8, grammarAccess.getPrimitiveTypeAccess().getBase64BinaryEnumLiteralDeclaration_8());
			}
		)
		    |
		(
			enumLiteral_9='byte'
			{
				$current = grammarAccess.getPrimitiveTypeAccess().getByteEnumLiteralDeclaration_9().getEnumLiteral().getInstance();
				newLeafNode(enumLiteral_9, grammarAccess.getPrimitiveTypeAccess().getByteEnumLiteralDeclaration_9());
			}
		)
	)
;

// Rule ConstraintIntervalType
ruleConstraintIntervalType returns [Enumerator current=null]
@init {
	enterRule();
}
@after {
	leaveRule();
}:
	(
		(
			enumLiteral_0='MIN'
			{
				$current = grammarAccess.getConstraintIntervalTypeAccess().getMinEnumLiteralDeclaration_0().getEnumLiteral().getInstance();
				newLeafNode(enumLiteral_0, grammarAccess.getConstraintIntervalTypeAccess().getMinEnumLiteralDeclaration_0());
			}
		)
		    |
		(
			enumLiteral_1='MAX'
			{
				$current = grammarAccess.getConstraintIntervalTypeAccess().getMaxEnumLiteralDeclaration_1().getEnumLiteral().getInstance();
				newLeafNode(enumLiteral_1, grammarAccess.getConstraintIntervalTypeAccess().getMaxEnumLiteralDeclaration_1());
			}
		)
		    |
		(
			enumLiteral_2='STRLEN'
			{
				$current = grammarAccess.getConstraintIntervalTypeAccess().getStrlenEnumLiteralDeclaration_2().getEnumLiteral().getInstance();
				newLeafNode(enumLiteral_2, grammarAccess.getConstraintIntervalTypeAccess().getStrlenEnumLiteralDeclaration_2());
			}
		)
		    |
		(
			enumLiteral_3='REGEX'
			{
				$current = grammarAccess.getConstraintIntervalTypeAccess().getRegexEnumLiteralDeclaration_3().getEnumLiteral().getInstance();
				newLeafNode(enumLiteral_3, grammarAccess.getConstraintIntervalTypeAccess().getRegexEnumLiteralDeclaration_3());
			}
		)
		    |
		(
			enumLiteral_4='MIMETYPE'
			{
				$current = grammarAccess.getConstraintIntervalTypeAccess().getMimetypeEnumLiteralDeclaration_4().getEnumLiteral().getInstance();
				newLeafNode(enumLiteral_4, grammarAccess.getConstraintIntervalTypeAccess().getMimetypeEnumLiteralDeclaration_4());
			}
		)
		    |
		(
			enumLiteral_5='SCALING'
			{
				$current = grammarAccess.getConstraintIntervalTypeAccess().getScalingEnumLiteralDeclaration_5().getEnumLiteral().getInstance();
				newLeafNode(enumLiteral_5, grammarAccess.getConstraintIntervalTypeAccess().getScalingEnumLiteralDeclaration_5());
			}
		)
	)
;

RULE_SIGNEDINT : '-' RULE_INT;

RULE_FLOAT : '-'? RULE_INT '.' RULE_INT;

fragment RULE_DATE : '0'..'9' '0'..'9' '0'..'9' '0'..'9' '-' '0'..'9' '0'..'9' '-' '0'..'9' '0'..'9';

fragment RULE_TIME : '0'..'9' '0'..'9' ':' '0'..'9' '0'..'9' ':' '0'..'9' '0'..'9' RULE_TIMEZONE?;

fragment RULE_TIMEZONE : ('Z'|('+'|'-') '0'..'9' '0'..'9' ':' '0'..'9' '0'..'9');

RULE_DATETIME : RULE_DATE 'T' RULE_TIME;

RULE_VERSION : ('0'..'9')* '.' ('0'..'9')* '.' ('0'..'9')* ('-' RULE_ID)?;

RULE_ID : '^'? ('a'..'z'|'A'..'Z'|'_') ('a'..'z'|'A'..'Z'|'_'|'0'..'9')*;

RULE_INT : ('0'..'9')+;

RULE_STRING : ('"' ('\\' .|~(('\\'|'"')))* '"'|'\'' ('\\' .|~(('\\'|'\'')))* '\'');

RULE_ML_COMMENT : '/*' ( options {greedy=false;} : . )*'*/';

RULE_SL_COMMENT : '//' ~(('\n'|'\r'))* ('\r'? '\n')?;

RULE_WS : (' '|'\t'|'\r'|'\n')+;

RULE_ANY_OTHER : .;
